#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ${package}.web.infra;

import java.util.Arrays;
import java.util.Collection;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import org.apache.commons.lang3.StringUtils;

/**
 *
 * @author yuichi.kuwahara
 */
@FacesConverter(value = "collectionConverter", forClass = String.class)
public class CollectionConverter implements Converter {

	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		return Arrays.asList(StringUtils.split(value, ","));
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object value) {
		if (value == null) {
			return "";
		}
		if (value instanceof String) {
			return (String)value;
		} else if (value instanceof Collection) {
			return StringUtils.join((Collection)value, ",");
		} else {
			return value.toString();
		}
	}
	
}
